VERSION 2.00
Begin Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5955
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   3855
   Height          =   6360
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   5955
   ScaleWidth      =   3855
   Top             =   1140
   Width           =   3975
   Begin Timer Timer1 
      Left            =   3975
      Top             =   1785
   End
   Begin ListBox List1 
      Height          =   5490
      Left            =   225
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   195
      Width           =   3315
   End
End
Option Explicit
'
' API Declarations
'
Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long
Const LB_FINDSTRING = &H410
Const LB_ERR = (-1)
'
' Flag to indicate if keystrokes are being accepted.
'
Dim ExtendingSearch As Integer
'
' Last keystroke time.
'
Dim LastKey As Double
'
' Timer settings
'
Const msTimeLimit = 1000   '1 second
Const msCheckEvery = 50    '1/20 second

Sub Form_Load ()
   Dim file As String
   '
   ' Fill list box with filenames.
   '
   file = Dir(Environ("windir") & "\*.*")
   'file = Dir("c:\win\*.*")
   Do While Len(file)
      List1.AddItem file
      file = Dir
   Loop
   '
   ' Set timer interval and initialize vars.
   '
   Timer1.Interval = msCheckEvery
   LastKey = Now
End Sub

Sub List1_GotFocus ()
   '
   ' Restart timer and clear search string.
   '
   Timer1.Enabled = True
   ExtendingSearch = False
End Sub

Sub List1_KeyPress (KeyAscii As Integer)
   Static Search As String
   Dim Index As Long
   '
   ' Start over if delay was too long.
   '
   If Not ExtendingSearch Then
      Search = ""
      ExtendingSearch = True
   End If
   '
   ' Only react to
   '
   If KeyAscii >= 32 Then
      '
      ' Extend search string, and keep looking.
      '
      Search = Search & Chr(KeyAscii)
      Index = SendMessage(CInt(List1.hWnd), LB_FINDSTRING, CInt(List1.ListIndex), ByVal Search)
      If Index <> LB_ERR Then
         '
         ' Found a match! Reset listindex.
         '
         List1.ListIndex = Index
      Else
         '
         ' No match. Trim last character from search string.
         '
         Search = Left(Search, Len(Search) - 1)
         Beep
      End If
      '
      ' Record when key was pressed.
      '
      LastKey = Now
      '
      ' Consume keystroke so VB doesn't automatically
      ' move list to entry that starts with last key.
      '
      KeyAscii = 0
   End If
End Sub

Sub List1_LostFocus ()
   '
   ' Turn off timer for efficiency.
   '
   Timer1.Enabled = False
End Sub

Sub Timer1_Timer ()
   Dim Elapsed As Double
   '
   ' Check if more than allowed time has elapsed.
   '
   If ExtendingSearch Then
      Elapsed = Now - LastKey
      If (Elapsed * 86400) > (msTimeLimit / 1000) Then
         ExtendingSearch = False
      End If
   End If
End Sub

