VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Searching Listbox Demo"
   ClientHeight    =   5940
   ClientLeft      =   1230
   ClientTop       =   1620
   ClientWidth     =   3990
   Height          =   6375
   Left            =   1170
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5940
   ScaleWidth      =   3990
   Top             =   1245
   Width           =   4110
   Begin VB.CommandButton Command1 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   315
      Left            =   2160
      TabIndex        =   2
      Top             =   5475
      Width           =   975
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   3300
      Top             =   5490
   End
   Begin VB.ListBox List1 
      Height          =   5100
      IntegralHeight  =   0   'False
      Left            =   150
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   135
      Width           =   3585
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BorderStyle     =   1  'Fixed Single
      Caption         =   " Enter text to seach for. "
      Height          =   255
      Left            =   180
      TabIndex        =   1
      Tag             =   " Enter text to seach for. "
      Top             =   5460
      Width           =   1755
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
'
' API Declarations
'
#If Win16 Then
   Private Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long
   Private Const LB_FINDSTRING = &H410
#ElseIf Win32 Then
   Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
   Private Const LB_FINDSTRING = &H18F
#End If
Private Const LB_ERR = (-1)
'
' Flag to indicate if keystrokes are being accepted.
'
Private ExtendingSearch As Boolean
'
' Last keystroke time.
'
Private LastKey As Double
'
' Timer settings
'
Private Const msTimeLimit = 2000   '2 seconds
Private Const msCheckEvery = 200   '1/5 second

Private Sub Command1_Click()
   Unload Me
End Sub

Private Sub Form_Load()
   Dim file As String
   '
   ' Fill list box with filenames.
   '
   file = Dir(Environ("windir") & "\*.*")
   'file = Dir("c:\win\*.*")
   Do While Len(file)
      List1.AddItem file
      file = Dir()
   Loop
   '
   ' Set timer interval and initialize vars.
   '
   Timer1.Interval = msCheckEvery
   LastKey = Now
End Sub

Private Sub Form_Resize()
   '
   ' Resize controls to fit form.
   '
   List1.Move List1.Left, List1.Top, Me.ScaleWidth - List1.Left * 2, Me.ScaleHeight - List1.Top - Command1.Height - List1.Left
   Command1.Move List1.Left + List1.Width - Command1.Width, Me.ScaleHeight - Command1.Height - List1.Left \ 2
   Label1.Top = Command1.Top + (Command1.Height - Label1.Height) \ 2
End Sub

Private Sub List1_GotFocus()
   '
   ' Restart timer and clear search string.
   '
   Timer1.Enabled = True
   ExtendingSearch = False
End Sub

Private Sub List1_KeyPress(KeyAscii As Integer)
   Static Search As String
   Dim Index As Long
   Dim DoSearch As Boolean
   '
   ' Start over if delay was too long.
   '
   If Not ExtendingSearch Then
      Search = ""
      ExtendingSearch = True
      Index = List1.ListIndex
   Else
      Index = -1
   End If
   '
   ' Check for valid keystrokes.
   '
   If KeyAscii = vbKeyBack Then
      '
      ' Allow user to take back last key.
      '
      If Len(Search) Then
         Search = Left(Search, Len(Search) - 1)
         Label1 = " " & Search & " "
         If Len(Search) Then
            DoSearch = True
         Else
            DoSearch = False
         End If
      End If
   ElseIf KeyAscii >= vbKeySpace Then
      '
      ' Append latest key.
      '
      Search = Search & Chr(KeyAscii)
      Label1 = " " & Search & " "
      DoSearch = True
   End If
   '
   ' Perform search after valid keystrokes.
   '
   If DoSearch Then
      Index = SendMessage(List1.hWnd, LB_FINDSTRING, Index, ByVal Search)
      If Index <> LB_ERR Then 'Found a match!
         List1.ListIndex = Index
      Else 'No match
         Search = Left(Search, Len(Search) - 1)
         Beep
         Label1 = " " & Search & " "
      End If
      '
      ' Record when key was pressed, and consume
      ' keystroke so VB doesn't automatically move
      ' list to entry that starts with last key.
      '
      LastKey = Now
      KeyAscii = 0
   End If
End Sub

Private Sub List1_LostFocus()
   '
   ' Turn off timer for efficiency.
   '
   Timer1.Enabled = False
End Sub

Private Sub Timer1_Timer()
   Dim Elapsed As Double
   '
   ' Check if more than allowed time has elapsed.
   '
   If ExtendingSearch Then
      Elapsed = Now - LastKey
      If (Elapsed * 86400) > (msTimeLimit / 1000) Then
         ExtendingSearch = False
         Label1 = Label1.Tag
      End If
   End If
End Sub
